Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.cpp	(revision 12)
@@ -187,4 +187,9 @@
     m_acCUMvField[1].create( uiNumPartition );
     
+#if POZNAN_EIVD_CALC_PRED_DATA
+    m_acCUMvField2nd[0].create( uiNumPartition );
+    m_acCUMvField2nd[1].create( uiNumPartition );
+#endif
+    
 #if HHI_DMM_WEDGE_INTRA
     m_puiWedgeFullTabIdx       = (UInt*)xMalloc(UInt, uiNumPartition);
@@ -210,4 +215,9 @@
     m_acCUMvField[0].setNumPartition(uiNumPartition );
     m_acCUMvField[1].setNumPartition(uiNumPartition );
+
+#if POZNAN_EIVD_CALC_PRED_DATA
+    m_acCUMvField2nd[0].setNumPartition(uiNumPartition );
+    m_acCUMvField2nd[1].setNumPartition(uiNumPartition );
+#endif
   }
   
@@ -296,4 +306,10 @@
     if ( m_piContourPredTexDeltaDC2  ) { xFree(m_piContourPredTexDeltaDC2);  m_piContourPredTexDeltaDC2  = NULL; }
 #endif    
+    
+#if POZNAN_EIVD_CALC_PRED_DATA
+    m_acCUMvField2nd[0].destroy();
+    m_acCUMvField2nd[1].destroy();
+#endif
+
   }
   
@@ -388,4 +404,9 @@
   m_acCUMvField[0].clearMvField();
   m_acCUMvField[1].clearMvField();
+  
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].clearMvField();
+  m_acCUMvField2nd[1].clearMvField();
+#endif
   
   UInt uiTmp = m_puhWidth[0]*m_puhHeight[0];
@@ -508,4 +529,9 @@
   m_acCUMvField[1].clearMvField();
 
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].clearMvField();
+  m_acCUMvField2nd[1].clearMvField();
+#endif
+
 #if HHI_DMM_WEDGE_INTRA
   memset( m_puiWedgeFullTabIdx,  0, iSizeInUInt   );
@@ -617,4 +643,9 @@
   m_uiEntropySliceStartCU   = pcCU->getEntropySliceStartCU();
 
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].clearMvField();
+  m_acCUMvField2nd[1].clearMvField();
+#endif
+
 #if HHI_DMM_WEDGE_INTRA
   memset( m_puiWedgeFullTabIdx,  0, iSizeInUInt   );
@@ -719,4 +750,14 @@
   m_acCUMvField[1].setMvdPtr(pcCU->getCUMvField(REF_PIC_LIST_1)->getMvd()    + uiPart);
   m_acCUMvField[1].setRefIdxPtr(pcCU->getCUMvField(REF_PIC_LIST_1)->getRefIdx() + uiPart);
+
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].setMvPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_0)->getMv()     + uiPart);
+  m_acCUMvField2nd[0].setMvdPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_0)->getMvd()    + uiPart);
+  m_acCUMvField2nd[0].setRefIdxPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_0)->getRefIdx() + uiPart);
+  m_acCUMvField2nd[1].setMvPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_1)->getMv()     + uiPart);
+  m_acCUMvField2nd[1].setMvdPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_1)->getMvd()    + uiPart);
+  m_acCUMvField2nd[1].setRefIdxPtr(pcCU->getCUMvField2nd(REF_PIC_LIST_1)->getRefIdx() + uiPart);
+#endif
+
   m_uiSliceStartCU        = pcCU->getSliceStartCU();
   m_uiEntropySliceStartCU = pcCU->getEntropySliceStartCU();
@@ -787,4 +828,11 @@
   m_acCUMvField[eRefPicList].setMvdPtr(pcCU->getCUMvField(eRefPicList)->getMvd()    + uiAbsPartIdx);
   m_acCUMvField[eRefPicList].setRefIdxPtr(pcCU->getCUMvField(eRefPicList)->getRefIdx() + uiAbsPartIdx);
+
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[eRefPicList].setMvPtr(pcCU->getCUMvField2nd(eRefPicList)->getMv()     + uiAbsPartIdx);
+  m_acCUMvField2nd[eRefPicList].setMvdPtr(pcCU->getCUMvField2nd(eRefPicList)->getMvd()    + uiAbsPartIdx);
+  m_acCUMvField2nd[eRefPicList].setRefIdxPtr(pcCU->getCUMvField2nd(eRefPicList)->getRefIdx() + uiAbsPartIdx);
+#endif
+
 #if HHI_MPI
   m_piTextureModeDepth = pcCU->getTextureModeDepth() + uiAbsPartIdx;
@@ -857,4 +905,9 @@
   m_acCUMvField[1].copyFrom( pcCU->getCUMvField( REF_PIC_LIST_1 ), pcCU->getTotalNumPart(), uiOffset );
   
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].copyFrom( pcCU->getCUMvField2nd( REF_PIC_LIST_0 ), pcCU->getTotalNumPart(), uiOffset );
+  m_acCUMvField2nd[1].copyFrom( pcCU->getCUMvField2nd( REF_PIC_LIST_1 ), pcCU->getTotalNumPart(), uiOffset );
+#endif
+
   UInt uiTmp  = g_uiMaxCUWidth*g_uiMaxCUHeight >> (uiDepth<<1);
   UInt uiTmp2 = uiPartUnitIdx*uiTmp;
@@ -943,4 +996,9 @@
   m_acCUMvField[0].copyTo( rpcCU->getCUMvField( REF_PIC_LIST_0 ), m_uiAbsIdxInLCU );
   m_acCUMvField[1].copyTo( rpcCU->getCUMvField( REF_PIC_LIST_1 ), m_uiAbsIdxInLCU );
+  
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].copyTo( rpcCU->getCUMvField2nd( REF_PIC_LIST_0 ), m_uiAbsIdxInLCU );
+  m_acCUMvField2nd[1].copyTo( rpcCU->getCUMvField2nd( REF_PIC_LIST_1 ), m_uiAbsIdxInLCU );
+#endif
   
   UInt uiTmp  = (g_uiMaxCUWidth*g_uiMaxCUHeight)>>(uhDepth<<1);
@@ -1030,4 +1088,9 @@
   m_acCUMvField[0].copyTo( rpcCU->getCUMvField( REF_PIC_LIST_0 ), m_uiAbsIdxInLCU, uiPartStart, uiQNumPart );
   m_acCUMvField[1].copyTo( rpcCU->getCUMvField( REF_PIC_LIST_1 ), m_uiAbsIdxInLCU, uiPartStart, uiQNumPart );
+  
+#if POZNAN_EIVD_CALC_PRED_DATA
+  m_acCUMvField2nd[0].copyTo( rpcCU->getCUMvField2nd( REF_PIC_LIST_0 ), m_uiAbsIdxInLCU, uiPartStart, uiQNumPart );
+  m_acCUMvField2nd[1].copyTo( rpcCU->getCUMvField2nd( REF_PIC_LIST_1 ), m_uiAbsIdxInLCU, uiPartStart, uiQNumPart );
+#endif
   
   UInt uiTmp  = (g_uiMaxCUWidth*g_uiMaxCUHeight)>>((uhDepth+uiPartDepth)<<1);
@@ -2697,4 +2760,9 @@
 #endif
   
+#if POZNAN_EIVD
+  Bool bEIVDMerge = getSlice()->getMP()->isEIVDEnabled();
+  UInt uiEIVDAddr = POZNAN_EIVD_MRG_CAND;
+#endif
+  
   bool abCandIsInter[ MRG_MAX_NUM_CANDS ];
   for( UInt ui = 0; ui < MRG_MAX_NUM_CANDS; ++ui )
@@ -2712,5 +2780,5 @@
   }
   if( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
     && !pcCULeft->isCUSkiped( uiLeftPartIdx )
 #endif
@@ -2742,5 +2810,5 @@
   }
   if ( pcCUAbove && !pcCUAbove->isIntra( uiAbovePartIdx ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
     && !pcCUAbove->isCUSkiped( uiAbovePartIdx )
 #endif
@@ -3191,12 +3259,63 @@
 #endif
 
+#if POZNAN_EIVD
+  //===== add point-to-point merge with depth maps =====
+  if ( bEIVDMerge )
+  {
+    //prediction of motion data for points with disocclusion:
+	UInt uiRefArrayAddr = uiEIVDAddr;
+	for(UInt ui=0; ui<MRG_MAX_NUM_CANDS; ui++) if ( ui!=uiEIVDAddr && abCandIsInter[ui] ) {uiRefArrayAddr = ui; break;}	
+	if(uiRefArrayAddr != uiEIVDAddr)
+	{
+		puhInterDirNeighbours[uiEIVDAddr] = puhInterDirNeighbours[uiRefArrayAddr];
+		pcMvFieldNeighbours[uiEIVDAddr << 1].setMvField(pcMvFieldNeighbours[uiRefArrayAddr << 1].getMv(),pcMvFieldNeighbours[uiRefArrayAddr << 1].getRefIdx());
+		pcMvFieldNeighbours[(uiEIVDAddr << 1)+1].setMvField(pcMvFieldNeighbours[(uiRefArrayAddr << 1)+1].getMv(),pcMvFieldNeighbours[(uiRefArrayAddr << 1)+1].getRefIdx());
+	}
+	else
+	{
+		TComMv cMVzero; cMVzero.setZero();
+		if( getSlice()->isInterB() ) 
+		{
+			puhInterDirNeighbours[uiEIVDAddr] = 3;
+			pcMvFieldNeighbours[uiEIVDAddr << 1].setMvField(cMVzero,0);
+			pcMvFieldNeighbours[(uiEIVDAddr << 1)+1].setMvField(cMVzero,0);
+		}
+		else 
+		{
+			if(getSlice()->getNumRefIdx(REF_PIC_LIST_0)>0) 
+			{
+				puhInterDirNeighbours[uiEIVDAddr] = 1;
+				pcMvFieldNeighbours[uiEIVDAddr << 1].setMvField(cMVzero,0);
+			}
+			else if(getSlice()->getNumRefIdx(REF_PIC_LIST_1)>0) 
+			{
+				puhInterDirNeighbours[uiEIVDAddr] = 2;
+				pcMvFieldNeighbours[(uiEIVDAddr << 1)+1].setMvField(cMVzero,0);
+			}
+			else puhInterDirNeighbours[uiEIVDAddr] = 0;
+		}
+	}	
+	if(puhInterDirNeighbours[uiEIVDAddr])
+	{		
+		abCandIsInter[uiEIVDAddr] = true;
+		puiNeighbourCandIdx[uiEIVDAddr] = uiEIVDAddr + 1;
+	}
+  }
+#endif
+
 
   //===== remove duplicates =====
   for( UInt uiOuter = 0; uiOuter < MRG_MAX_NUM_CANDS; uiOuter++ )
   {
+#if POZNAN_EIVD
+    if(uiOuter==POZNAN_EIVD_MRG_CAND) continue;
+#endif
     if( abCandIsInter[ uiOuter ] && ( puiNeighbourCandIdx[uiOuter] == uiOuter + 1 ) )
     {
       for( UInt uiIter = uiOuter + 1; uiIter < MRG_MAX_NUM_CANDS; uiIter++ )
       {
+#if POZNAN_EIVD
+        if(uiIter==POZNAN_EIVD_MRG_CAND) continue;
+#endif
         if( abCandIsInter[ uiIter ] )
         {
@@ -3280,5 +3399,5 @@
   {
     if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
        && !pcCorner->isCUSkiped( uiCornerPUIdx )
 #endif
@@ -3319,5 +3438,5 @@
   {
     if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
        && !pcCorner->isCUSkiped( uiCornerPUIdx )
 #endif
@@ -4441,6 +4560,6 @@
   if (pColCU->isIntra(uiPartIdxCenter))
     return false;
-
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+  
+#if POZNAN_CU_SKIP
   if (pColCU->isSkipped(uiPartIdxCenter))
     return false;
@@ -4804,4 +4923,25 @@
   }
 #endif
+
+#if POZNAN_EIVD_CALC_PRED_DATA
+  pcCU->getCUMvField2nd( REF_PIC_LIST_0 )->copyTo( &m_acCUMvField2nd[0], -Int(uiAbsPartIdxSrc) + uiAbsPartIdxDst, uiAbsPartIdxSrc, uiNumPartition );
+  pcCU->getCUMvField2nd( REF_PIC_LIST_1 )->copyTo( &m_acCUMvField2nd[1], -Int(uiAbsPartIdxSrc) + uiAbsPartIdxDst, uiAbsPartIdxSrc, uiNumPartition );
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
+  for( UInt ui = 0; ui < uiNumPartition; ui++ )
+  {
+    m_acCUMvField2nd[0].getMv( uiAbsPartIdxDst + ui ) += TComMv( 2, 2 );
+    m_acCUMvField2nd[0].getMv( uiAbsPartIdxDst + ui ) >>= 2;
+
+    m_acCUMvField2nd[1].getMv( uiAbsPartIdxDst + ui ) += TComMv( 2, 2 );
+    m_acCUMvField2nd[1].getMv( uiAbsPartIdxDst + ui ) >>= 2;
+
+    m_acCUMvField2nd[0].getMvd( uiAbsPartIdxDst + ui ) += TComMv( 2, 2 );
+    m_acCUMvField2nd[0].getMvd( uiAbsPartIdxDst + ui ) >>= 2;
+
+    m_acCUMvField2nd[1].getMvd( uiAbsPartIdxDst + ui ) += TComMv( 2, 2 );
+    m_acCUMvField2nd[1].getMvd( uiAbsPartIdxDst + ui ) >>= 2;
+  }
+#endif
+#endif
 }
 #endif
@@ -4812,2 +4952,314 @@
   riPosY = g_auiRasterToPelY[g_auiZscanToRaster[uiAbsPartIndex]] + getCUPelY();  
 }
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+Int TComDataCU::CuQpIncrementFunction(Pel uiBlockMax)
+{
+  if((uiBlockMax >> g_uiBitIncrement) >= 256 || (uiBlockMax >> g_uiBitIncrement) <0)
+  {
+    fprintf(stderr, "Bitincrement = %d, uiBlockMax = %d\n", g_uiBitIncrement, uiBlockMax);
+    exit(333);
+  }
+  Float fVal = (Float)((255 - (uiBlockMax >> g_uiBitIncrement)) >> 4);
+  fVal = (fVal * fVal);
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC
+  fVal = (Float)( fVal + getPic()->getTextureCuDeltaQpOffset() * 32); // add offset, if offset is negative than objects in front will have smaller QP than originaly - quality in front will be increased and in bacground will be decreased
+  fVal = (Float)( fVal * getPic()->getTextureCuDeltaQpMul()); // 
+#else 
+  fVal = (Float)( fVal + POZNAN_TEXTURE_TU_DELTA_QP_OFFSET * 32); // add offset, if offset is negative objects in front will have smaller QP than in original approach - quality in front will be increased and in bacground will be decreased
+  fVal = (Float)( fVal * POZNAN_TEXTURE_TU_DELTA_QP_MUL); // 
+#endif
+  return (Int)fVal >> 5;
+}
+ Int  TComDataCU::getQpOffsetForTextCU(UInt uiPartIdx, Bool bIsIntra)
+ {
+   //if(!isTexture(getSlice()->getViewId()))
+   if(this->getPic()->getSlice(0)->getSPS()->isDepth())
+   {
+     return 0;
+   }
+#if POZNAN_TEXTURE_TU_DELTA_QP_NOT_IN_BASE_VIEW
+   //if(!getPic()->getIsSideView())
+   if(this->getPic()->getViewIdx() == 0)//KUBA czy indeksy na pewno s¹ od zera?
+   {
+     return 0;
+   }
+#endif
+   UInt iCuAddr = getAddr();
+   //TComPic * pcDepthPic = getPic()->getDepthPic();
+   TComPicYuv * pcDepthPicYUV = getPic()->getPicYuvSynthDepth();
+   if(pcDepthPicYUV /*pcDepthPic*/ == NULL)
+   {
+    char errortext[200];
+    sprintf(errortext, "depth map expected");
+    fprintf(stderr, "%s\n", errortext);
+    exit(123);
+   }
+   //TComDataCU* rpcCUDepth = pcDepthPic->getCU(iCuAddr);
+   Pel uiDepthLumaTransformBlockMax;
+   if(bIsIntra)
+   {
+     // in intra block CU each TU block has QP chosen separatly so dQP is calculated for TU
+     uiDepthLumaTransformBlockMax = getDepthLumaTransformBlockMax( pcDepthPicYUV /*rpcCUDepth*/, iCuAddr, uiPartIdx );
+   }
+   else
+   {
+     // in inter block CU all TU block has the same QP so dQP is calculated for CU
+     uiDepthLumaTransformBlockMax = getDepthLumaCodingBlockMax( pcDepthPicYUV /*rpcCUDepth*/, iCuAddr, uiPartIdx );
+   }
+#if POZNAN_NONLINEAR_DEPTH
+   //Pel liczby_w[256];
+   //Pel liczby_t[256];
+   //Pel liczby_o[256];
+   //Float p = 1.9;
+   //TComPowerConverter powconv_t(p, g_uiBitIncrement, g_uiBitIncrement); 
+   //TComPowerConverter powconv_o(1.0f/p, g_uiBitIncrement, g_uiBitIncrement); 
+   //for(UInt i = 0; i <256; i++)
+   //{
+   //  liczby_w[i] = i<<2;
+   //  liczby_t[i] = (Pel)( powconv_t(liczby_w[i]) + 0.5);
+   //  liczby_o[i] = (Pel)( powconv_o(liczby_t[i]) + 0.5)>>2;
+   //}
+   //printf("\n");
+   //if(bIsIntra)printf("intra ");
+   //else        printf("inter ");
+   //printf("in:%d, ", uiDepthLumaTransformBlockMax);
+   Float p = 1.0f / getSlice()->getSPS()->getDepthPower();
+   //printf("p:%f, ", p);
+   TComPowerConverter powconv(p, g_uiBitIncrement, g_uiBitIncrement); 
+   uiDepthLumaTransformBlockMax = (Pel)( powconv(uiDepthLumaTransformBlockMax) + 0.5);
+   //printf("out:%d, ", uiDepthLumaTransformBlockMax);
+#endif
+   Int iDeltaQP = CuQpIncrementFunction(uiDepthLumaTransformBlockMax);
+   //printf("dQP:%d ", iDeltaQP);
+#if POZNAN_TEXTURE_TU_DELTA_QP_TOP_BOTTOM_CU_ROW
+   Int iMaxCUHeight = this->getPic()->getPicSym()->getMaxCUHeight();
+   Int iPicHeight   = this->getPic()->getPicSym()->getPicHeight();
+   Int iLastPelYInFirstCURow = 0 + iMaxCUHeight;
+   Int iFirstPelYInLastCURow = iPicHeight - iMaxCUHeight;
+   Int iCUStartPelY = getCUPelY();
+   if((iCUStartPelY <= iLastPelYInFirstCURow) || (iCUStartPelY >= iFirstPelYInLastCURow))
+   {
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC
+     iDeltaQP += getPic()->getTextureCuDeltaQpTopBottomRow();// POZNAN_TEXTURE_TU_DELTA_QP_TOP_BOTTOM_CU_ROW;
+#else
+     iDeltaQP += POZNAN_TEXTURE_TU_DELTA_QP_TOP_BOTTOM_ROW_VAL;// POZNAN_TEXTURE_TU_DELTA_QP_TOP_BOTTOM_CU_ROW;
+#endif
+   }
+#endif
+   return iDeltaQP;
+ }
+
+Int cmpProc(const Void *arg1, const Void *arg2)
+{
+    return *((Pel*)arg2) - *((Pel*)arg1);
+}
+
+// Function gets median value of depth block that has the same size and position as texture block that calls this function
+Pel  TComDataCU::getDepthLumaCodingBlockMedian( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  static Pel pSortTable [64 * 64];
+  Int CUWidth, CUHeight;
+  sortDepthLumaCodingBlock( pcDepthPicYUV /*rpcCUDepth*/, iCuAddr, uiPartIdx, pSortTable, CUWidth, CUHeight );
+  return pSortTable[(CUHeight * CUWidth) / 2];
+}
+
+// Function gets maximal value of depth block that has the same size and position as texture block that calls this function
+Pel TComDataCU::getDepthLumaCodingBlockMax( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  return maxDepthLumaCodingBlock( pcDepthPicYUV /*rpcCUDepth*/, iCuAddr, uiPartIdx);  
+}
+Void TComDataCU::sortDepthLumaCodingBlock ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx, Pel * pSortTable, Int& CUWidth, Int& CUHeight )
+{
+  Int x, y;
+  UInt uiAbsZorderIdx  = getZorderIdxInCU() + uiPartIdx;
+  // CU size: 
+  CUHeight = getHeight(uiPartIdx); // Size is based on coded texture block size not on depth picture size
+  CUWidth  = getWidth(uiPartIdx); 
+  // uiAbsZorderIdx is z order idx of one particular base block (4x4 pix) in block that we process
+  // What we need is z-order idx of first Base block (4x4 pix) in this block
+  Int iNumBase4x4InBlock = (CUWidth >> 2) * (CUHeight >> 2);
+
+  UInt uiAbsZorderIdxBlockStart = (uiAbsZorderIdx / iNumBase4x4InBlock) * iNumBase4x4InBlock;
+  // Address of block
+  Pel* pPel   = pcDepthPicYUV/*rpcCUDepth->getPic()->getPicYuvRec()*/->getLumaAddr ( iCuAddr, uiAbsZorderIdxBlockStart );
+
+  Int p =0;
+  Int iStride  = getPic()->getPicYuvRec()->getStride();
+  for ( y = CUHeight - 1; y >= 0; y-- )
+  {
+    for ( x = CUWidth - 1; x >= 0; x-- )
+    {
+      pSortTable[p] = pPel[x]; ++p;
+    }
+    pPel += iStride;
+  }
+  // sort elements
+  qsort(pSortTable, CUHeight * CUWidth, sizeof(Pel), cmpProc);
+}
+
+Pel TComDataCU::maxDepthLumaCodingBlock ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx)
+{
+  Int x, y;
+  UInt uiAbsZorderIdx  = getZorderIdxInCU() + uiPartIdx;
+  // CU size: 
+  Int CUHeight = getHeight(uiPartIdx); // Size is based on coded texture block size not on depth picture size
+  Int CUWidth  = getWidth(uiPartIdx); 
+  // uiAbsZorderIdx is z order idx of one particular base block (4x4 pix) in block that we process
+  // What we need is z-order idx of first Base block (4x4 pix) in this block
+  Int iNumBase4x4InBlock = (CUWidth >> 2) * (CUHeight >> 2);
+
+  UInt uiAbsZorderIdxBlockStart = (uiAbsZorderIdx / iNumBase4x4InBlock) * iNumBase4x4InBlock;
+  // Address of block
+  Pel* pPel   = pcDepthPicYUV/*rpcCUDepth->getPic()->getPicYuvRec()*/->getLumaAddr ( iCuAddr, uiAbsZorderIdxBlockStart );
+
+  Pel  pValue = 0;
+  Int  iStride = getPic()->getPicYuvRec()->getStride();
+  for ( y = CUHeight - 1; y >= 0; y-- )
+  {
+    for ( x = CUWidth - 1; x >= 0; x-- )
+    {
+      if (pPel[x]>pValue) pValue = pPel[x];
+    }
+    pPel += iStride;
+  }
+  return pValue;
+}
+
+// Function gets median value of depth block that has the same size and position as texture block that calls this function
+Pel  TComDataCU::getDepthLumaTransformBlockMedian( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  static Pel pSortTable [64 * 64];
+  Int TUWidth, TUHeight;
+  sortDepthLumaTransformBlock( pcDepthPicYUV/*rpcCUDepth*/, iCuAddr, uiPartIdx, pSortTable, TUWidth, TUHeight );
+  return pSortTable[(TUHeight * TUWidth) / 2];
+}
+
+// Function gets maximal value of depth block that has the same size and position as texture block that calls this function
+Pel TComDataCU::getDepthLumaTransformBlockMax( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  return maxDepthLumaTransformBlock( pcDepthPicYUV/*rpcCUDepth*/, iCuAddr, uiPartIdx );
+}
+Void TComDataCU::sortDepthLumaTransformBlock ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx, Pel * pSortTable, Int& TUWidth, Int& TUHeight )
+{
+  Int x, y;
+  UInt uiAbsZorderIdx  = getZorderIdxInCU() + uiPartIdx;
+  // CU size: 
+  TUHeight = getHeight(uiPartIdx); // Size is based on coded texture block size not on depth picture size
+  TUWidth  = getWidth(uiPartIdx); 
+  // correct CU size to trnsform size:
+  if( getTransformIdx(uiPartIdx) )
+  {
+    TUWidth  = TUWidth >> 1;
+    TUHeight = TUHeight >> 1;
+  }
+  // uiAbsZorderIdx is z order idx of one particular base block (4x4 pix) in block that we process
+  // What we need is z-order idx of first Base block (4x4 pix) in this block
+  Int iNumBase4x4InBlock = (TUWidth >> 2) * (TUHeight >> 2);
+
+  UInt uiAbsZorderIdxBlockStart = (uiAbsZorderIdx / iNumBase4x4InBlock) * iNumBase4x4InBlock;
+  // Address of block
+  Pel* pPel   = pcDepthPicYUV/*rpcCUDepth->getPic()->getPicYuvRec()*/->getLumaAddr ( iCuAddr, uiAbsZorderIdxBlockStart );
+
+  int p = 0;
+  Int  iStride  = getPic()->getPicYuvRec()->getStride();
+  for ( y = TUHeight - 1; y >= 0; y-- )
+  {
+    for ( x = TUWidth - 1; x >= 0; x-- )
+    {
+      pSortTable[p] = pPel[x];
+    }
+    pPel += iStride;
+  }
+  // sort elements
+  qsort(pSortTable, TUHeight * TUWidth, sizeof(Pel), cmpProc);
+}
+Pel TComDataCU::maxDepthLumaTransformBlock ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx)
+{
+  Int x, y;
+  UInt uiAbsZorderIdx  = getZorderIdxInCU() + uiPartIdx;
+  // CU size: 
+  Int TUHeight = getHeight(uiPartIdx); // Size is based on coded texture block size not on depth picture size
+  Int TUWidth  = getWidth(uiPartIdx); 
+  // correct CU size to trnsform size:
+  if( getTransformIdx(uiPartIdx) )
+  {
+    TUWidth  = TUWidth >> 1;
+    TUHeight = TUHeight >> 1;
+  }
+  // uiAbsZorderIdx is z order idx of one particular base block (4x4 pix) in block that we process
+  // What we need is z-order idx of first Base block (4x4 pix) in this block
+  Int iNumBase4x4InBlock = (TUWidth >> 2) * (TUHeight >> 2);
+
+  UInt uiAbsZorderIdxBlockStart = (uiAbsZorderIdx / iNumBase4x4InBlock) * iNumBase4x4InBlock;
+  // Address of block
+  Pel* pPel   = pcDepthPicYUV/*rpcCUDepth->getPic()->getPicYuvRec()*/->getLumaAddr ( iCuAddr, uiAbsZorderIdxBlockStart );
+
+  Pel pValue = 0;
+  Int iStride  = getPic()->getPicYuvRec()->getStride();
+  for ( y = TUHeight - 1; y >= 0; y-- )
+  {
+    for ( x = TUWidth - 1; x >= 0; x-- )
+    {
+      if (pPel[x]>pValue) pValue = pPel[x];
+    }
+    pPel += iStride;
+  }
+  return pValue;
+}
+// Function gets median value of depth block that has the same size and position as texture block that calls this function
+Pel  TComDataCU::getDepthLumaPredictionBlockMedian( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  static Pel pSortTable [64 * 64];
+  Int PUWidth, PUHeight;
+  sortDepthLumaPredictionBlock( pcDepthPicYUV/*rpcCUDepth*/, iCuAddr, uiPartIdx, pSortTable, PUWidth, PUHeight );
+  return pSortTable[(PUHeight * PUWidth) / 2];
+}
+
+// Function gets maximal value of depth block that has the same size and position as texture block that calls this function
+Pel  TComDataCU::getDepthLumaPredictionBlockMax( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx )
+{  
+  static Pel pSortTable [64 * 64];
+  Int PUWidth, PUHeight;
+  sortDepthLumaPredictionBlock( pcDepthPicYUV/*rpcCUDepth*/, iCuAddr, uiPartIdx, pSortTable, PUWidth, PUHeight );
+  return pSortTable[0];
+}
+Void TComDataCU::sortDepthLumaPredictionBlock ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx, Pel * pSortTable, Int& PUWidth, Int& PUHeight )
+{
+  Int x, y;
+  UInt uiAbsZorderIdx  = getZorderIdxInCU() + uiPartIdx;
+  // CU size: 
+  PUHeight = getHeight(uiPartIdx); // Size is based on coded texture block size not on depth picture size
+  PUWidth  = getWidth(uiPartIdx); 
+  // correct CU size to partition size:
+  if( getPartitionSize(uiPartIdx) == SIZE_Nx2N || getPartitionSize(uiPartIdx) == SIZE_NxN )
+  {
+    PUWidth = PUWidth >> 1;
+  }
+  if( getPartitionSize(uiPartIdx) == SIZE_2NxN || getPartitionSize(uiPartIdx) == SIZE_NxN )
+  {
+    PUHeight = PUHeight >> 1;
+  }
+  
+  // uiAbsZorderIdx is z order idx of one particular base block (4x4 pix) in block that we process
+  // What we need is z-order idx of first Base block (4x4 pix) in this block
+  Int iNumBase4x4InBlock = (PUWidth >> 2) * (PUHeight >> 2);
+  if(getPartitionSize(uiPartIdx) == SIZE_Nx2N)
+  {
+    iNumBase4x4InBlock = iNumBase4x4InBlock << 1; // KUBA if PU is Nx2N than to count start z-order idx we need to make such trick
+  }
+  UInt uiAbsZorderIdxBlockStart = (uiAbsZorderIdx / iNumBase4x4InBlock) * iNumBase4x4InBlock;
+  // Address of block
+  Pel* pPel   = pcDepthPicYUV/*rpcCUDepth->getPic()->getPicYuvRec()*/->getLumaAddr ( iCuAddr, uiAbsZorderIdxBlockStart );
+
+  UInt  uiStride  = getPic()->getPicYuvRec()->getStride();
+  for ( y = PUHeight - 1; y >= 0; y-- )
+  {
+    for ( x = PUWidth - 1; x >= 0; x-- )
+    {
+      pSortTable[y*PUWidth + x] = pPel[y*uiStride + x];
+    }
+  }
+  // sort elements
+  qsort(pSortTable, PUHeight * PUWidth, sizeof(Pel), cmpProc);
+}
+#endif
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDataCU.h	(revision 12)
@@ -105,4 +105,8 @@
 #endif//SNY_DQP
   
+#if POZNAN_EIVD_CALC_PRED_DATA
+  TComCUMvField m_acCUMvField2nd[2];              ///< array of motion vectors selected for points with no MP prediction available
+#endif
+  
   // -------------------------------------------------------------------------------------------------------------------
   // neighbour access variables
@@ -310,4 +314,8 @@
 #endif
   
+#if POZNAN_EIVD_CALC_PRED_DATA
+  TComCUMvField* getCUMvField2nd         ( RefPicList e )          { return  &m_acCUMvField2nd[e];  }
+#endif
+  
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for coding tool information
@@ -529,5 +537,5 @@
   Bool          isIntra   ( UInt uiPartIdx )  { return m_pePredMode[ uiPartIdx ] == MODE_INTRA; }
   Bool          isSkipped ( UInt uiPartIdx );                                                     ///< SKIP (no residual)
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
   Bool          isCUSkiped( UInt uiPartIdx )  { return m_pePredMode[ uiPartIdx ] == MODE_SYNTH; }
 #endif
@@ -588,4 +596,19 @@
 #endif //QC_MDCS
 
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+ Int            CuQpIncrementFunction  ( Pel uiBlockMax );
+ Int            getQpOffsetForTextCU   ( UInt uiPartIdx, Bool bIsIntra );
+ Pel            getDepthLumaCodingBlockMedian    ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Pel            getDepthLumaCodingBlockMax       ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Void           sortDepthLumaCodingBlock         ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx, Pel * pSortTable, Int& TUWidth, Int& TUHeight);
+ Pel            maxDepthLumaCodingBlock          ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Pel            getDepthLumaTransformBlockMedian ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Pel            getDepthLumaTransformBlockMax    ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Void           sortDepthLumaTransformBlock      ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx , Pel * pSortTable, Int& TUWidth, Int& TUHeight);
+ Pel            maxDepthLumaTransformBlock       ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Pel            getDepthLumaPredictionBlockMedian( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Pel            getDepthLumaPredictionBlockMax   ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx );
+ Void           sortDepthLumaPredictionBlock     ( TComPicYuv * pcDepthPicYUV/*TComDataCU* rpcCUDepth*/, UInt iCuAddr, UInt uiPartIdx , Pel * pSortTable, Int& PUWidth, Int& PUHeight);
+#endif
 };
 
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 12)
@@ -478,4 +478,7 @@
   Pel*        pSrcSamples = pcPicYuv->getLumaAddr ( 0 );
   Pel*        pDstSamples = m_cTmpPic.getLumaAddr ( 0 );
+  Int         iDstStrideC  = m_cTmpPic.getCStride ( );
+  Pel*        pDstSamplesCb = m_cTmpPic.getCbAddr ( 0 );
+  Pel*        pDstSamplesCr = m_cTmpPic.getCrAddr ( 0 );
   Int         iMidOrgDpth = ( 1 << m_uiOrgDepthBitDepth ) >> 1;
   AOF( m_cTmpPic.getWidth () == iWidth  );
@@ -483,6 +486,16 @@
   for( Int iY = 0; iY < iHeight; iY++, pSrcSamples += iSrcStride, pDstSamples += iDstStride )
   {
+    if((iY%2) == 0 && iY != 0)
+    {
+      pDstSamplesCb += iDstStrideC; 
+      pDstSamplesCr += iDstStrideC;
+    }
     for( Int iX = 0; iX < iWidth; iX++ )
     {
+      if(pSrcSamples[ iX ] < 0)//== PDM_UNDEFINED_DEPTH)
+      {
+        pDstSamplesCb[ iX>>1 ] = 0;
+        pDstSamplesCr[ iX>>1 ] = 0;
+      }
       Int iOrgDepth     = ( pSrcSamples[ iX ] != PDM_UNDEFINED_DEPTH ? xGetOrigDepthFromVirtDepth( uiViewId, pSrcSamples[ iX ] ) : iMidOrgDpth );
       pDstSamples[ iX ] = Max( 0, Min( iMax, iOrgDepth ) );
@@ -494,4 +507,15 @@
   ::sprintf     ( acFilename, "%s_V%d.yuv", pFilenameBase, uiViewId );
   m_cTmpPic.dump( acFilename, ( pcPic->getPOC() != 0 )  );
+
+  pDstSamplesCb = m_cTmpPic.getCbAddr ( 0 );
+  pDstSamplesCr = m_cTmpPic.getCrAddr ( 0 );
+  for( Int iY = 0; iY < iHeight>>1; iY++, pDstSamplesCb += iDstStrideC, pDstSamplesCr += iDstStrideC)
+  {
+    for( Int iX = 0; iX < iWidth>>1; iX++ )
+    {
+      pDstSamplesCb[ iX ] = iMidOrgDpth;
+      pDstSamplesCr[ iX ] = iMidOrgDpth;
+    }
+  }
 }
 
@@ -971,7 +995,7 @@
     xInterPredictCUDepthMap( pcSubCU, pcSubDM );
     break;
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
   case MODE_SYNTH:
-    //What to do? Need Fix!
+    //What to do? Need Fix?
     xIntraPredictCUDepthMap( pcSubCU, pcSubDM );
     break;
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 12)
@@ -445,5 +445,5 @@
   //-- Set BS for Intra MB : BS = 4 or 3
   if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP && POZNAN_CU_SYNTH
      || pcCUP->isCUSkiped(uiPartP) || pcCUQ->isCUSkiped(uiPartQ) 
 #endif
@@ -455,5 +455,5 @@
   //-- Set BS for not Intra MB : BS = 2 or 1 or 0
   if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP && POZNAN_CU_SYNTH
      && !pcCUP->isCUSkiped(uiPartP) && !pcCUQ->isCUSkiped(uiPartQ) 
 #endif
@@ -536,5 +536,5 @@
   }   // enf of "if( not Intra )"
 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU //if one of the block is CUSkipped dont use loop filter
+#if POZNAN_CU_SKIP //if one of the block is CUSkipped dont use loop filter
   if ( pcCUP->isCUSkiped(uiPartP) || pcCUQ->isCUSkiped(uiPartQ))
   {
